import java.time.Duration;
import java.time.LocalDateTime;


public class Esecutore extends Thread {
	
	private MyQueue<Integer> codaVal; // coda in cui vengono mantenuti i valori da sommare alla variabile valore
	private int valore; // variabile numerica cumulativa inizialmente impostata a 0
	public final int SOGLIA = 100;
	private Publisher publisher;
	private Automa automa;
	private String outputSuono; // nome logico dell'interruttore che fa scattare il suono dell'allarme 
	
	
	public Esecutore(Publisher publisher, MyQueue<Integer> codaVal, Automa automa, String outputSuono) {
		this.codaVal = codaVal;
		this.valore = 0;
		this.automa = automa;
		this.publisher = publisher;
		this.outputSuono = outputSuono;
	}
	
	
	public void run() {
		final long DURATA_SUONO = 5; // l'allarme dura 5 minuti e poi smette di suonare
		int delta;
		LocalDateTime tempoAllarme = null;
		while(true) {
			while(automa.antifurtoAttivo()) { System.out.println("VALORE = "+ valore);
				delta = codaVal.receive();
				valore = valore + delta;
				if(valore >= SOGLIA && (!automa.allarme()) ) {	
					publisher.aggiungiComando("to/gruppo2/luci/gpio/"+outputSuono, "{cmd:1}");
					tempoAllarme = LocalDateTime.now();
				}
				else {
					if(automa.allarme()) {
						LocalDateTime tempoAttuale = LocalDateTime.now();
						long durata = Math.abs(Duration.between(tempoAllarme, tempoAttuale).toMinutes());
						if(valore < SOGLIA || durata >= DURATA_SUONO || !automa.antifurtoAttivo() ) {
							publisher.aggiungiComando("to/gruppo2/luci/gpio/"+outputSuono, "{cmd:0}"); // l'allarme viene disattivato
						}
					}
				}
				
			}
			if(!automa.antifurtoAttivo()) {
				reset();
			}
		}
	}

	
	public void aggiungiVal(int n) {
		codaVal.send(n);
	}
	
	public void reset() {
		valore = 0;
		codaVal.removeAll();
	}
	
}
